image: "registry.gitlab.com/e.ametrano/unity3d:androidunity"

stages:
  - analyze
  - test
  - build
  - deploy

variables:
  BUILD_NAME: ExampleProjectName

.unity_before_script: &unity_before_script
  before_script:
    - mkdir -p /root/.cache/unity3d
    - mkdir -p /root/.local/share/unity3d/Unity/
    - chmod -R 777 $(pwd)/
    - echo "$UNITY_LICENSE_CONTENT" | tr -d '\r' > /root/.local/share/unity3d/Unity/Unity_lic.ulf

stylecop: &stylecop
    stage: analyze
    image: "registry.gitlab.com/e.ametrano/unity3d:stylecop"
    allow_failure: true
    script: mono /Release/StyleCop.Baboon.exe Settings.StyleCop $(pwd) StyleCop.Baboon


.test: &test
  stage: test
  <<: *unity_before_script
  script: |
    xvfb-run --auto-servernum --server-args='-screen 0 640x480x24' \
      /opt/Unity/Editor/Unity \
        -projectPath $(pwd) \
        -runTests \
        -testPlatform $TEST_PLATFORM \
        -testResults $(pwd)/$TEST_PLATFORM-results.xml \
        -logFile \
        -batchmode
    UNITY_EXIT_CODE=$?
    if [ $UNITY_EXIT_CODE -eq 0 ]; then
      echo "Run succeeded, no failures occurred";
    elif [ $UNITY_EXIT_CODE -eq 2 ]; then
      echo "Run succeeded, some tests failed";
    elif [ $UNITY_EXIT_CODE -eq 3 ]; then
      echo "Run failure (other failure)";
    else
      echo "Unexpected exit code $UNITY_EXIT_CODE";
    fi
    cat $(pwd)/$TEST_PLATFORM-results.xml | grep test-run | grep Passed
    exit $UNITY_TEST_EXIT_CODE
  artifacts:
    paths:
    - $(pwd)/$TEST_PLATFORM-results.xml


test-editmode:
  <<: *test
  variables:
    TEST_PLATFORM: editmode

test-playmode:
  <<: *test
  variables:
    TEST_PLATFORM: playmode

.build: &build
  stage: build
  <<: *unity_before_script
  variables:
  script: |
    echo "Building for $BUILD_TARGET"
    export BUILD_PATH=./Builds/$BUILD_TARGET/
    mkdir -p $BUILD_PATH
    xvfb-run --auto-servernum --server-args='-screen 0 640x480x24' \
    /opt/Unity/Editor/Unity \
        -projectPath $(pwd) \
        -quit \
        -batchmode \
        -buildTarget $BUILD_TARGET \
        -customBuildTarget $BUILD_TARGET \
        -customBuildName $BUILD_NAME \
        -customBuildPath $BUILD_PATH \
        -customBuildOptions AcceptExternalModificationsToPlayer \
        -executeMethod BuildCommand.PerformBuild \
        -logFile
    ls -la $BUILD_PATH
    [ -n "$(ls -A $BUILD_PATH)" ] # fail job if build folder is empty
  artifacts:
    paths:
      - ./Builds/$BUILD_TARGET/
#    only:
#     - master

.build-iOS:
   <<: *build
   image: "registry.gitlab.com/e.ametrano/unity3d:iosunity"
   allow_failure: true
   variables:
       BUILD_TARGET: iOS
   cache:
     key: "$CI_JOB_NAME-$CI_COMMIT_REF_SLUG"
     paths:
      - ./Builds/$BUILD_TARGET/

build-Android:
   <<: *build
   image: "registry.gitlab.com/e.ametrano/unity3d:androidunity"
   variables:
     BUILD_TARGET: Android
   cache:
     key: "$CI_JOB_NAME-$CI_COMMIT_REF_SLUG"
     paths:
      - ./Builds/$BUILD_TARGET/

#Deployment

Prod-Android-HockeyApp:
  image: "registry.gitlab.com/e.ametrano/unity3d:android"
  stage: deploy
  cache:
  script: |
    ls
    cd $(pwd)/Builds/Android/$BUILD_NAME/MeinProjekt
    gradle build
    curl -F "status=2" -F "notify=0" -F "ipa=@/builds/e.ametrano/unity3d-gitlab-ci-example/Builds/Android/$BUILD_NAME/MeinProjekt/build/outputs/apk/debug/MeinProjekt-debug.apk" -H "X-HockeyAppToken:$HOCKEY_APP_TOKEN" https://rink.hockeyapp.net/api/2/apps/$HOCKEY_APP_ANDROID_ID_STAGGING/app_versions/upload
      
  artifacts:
    paths:
      - $(pwd)/Builds/Android/$BUILD_NAME/MeinProjekt/build/outputs/apk/
  only:
    - master
    
Stagging-Android-HockeyApp:
  image: "registry.gitlab.com/e.ametrano/unity3d:android"
  stage: deploy
  cache:
  script: |
    ls
    cd $(pwd)/Builds/Android/$BUILD_NAME/MeinProjekt
    gradle build
    curl -F "status=2" -F "notify=0" -F "ipa=@/builds/e.ametrano/unity3d-gitlab-ci-example/Builds/Android/$BUILD_NAME/MeinProjekt/build/outputs/apk/debug/MeinProjekt-debug.apk" -H "X-HockeyAppToken:$HOCKEY_APP_TOKEN" https://rink.hockeyapp.net/api/2/apps/$HOCKEY_APP_ANDROID_ID_STAGGING/app_versions/upload
      
  artifacts:
    paths:
      - $(pwd)/Builds/Android/$BUILD_NAME/MeinProjekt/build/outputs/apk/
  only:
    - stagging

Develop-Android-HockeyApp:
  image: "registry.gitlab.com/e.ametrano/unity3d:android"
  stage: deploy
  cache:
  script: |
    ls
    cd $(pwd)/Builds/Android/$BUILD_NAME/MeinProjekt
    gradle build
    curl -F "status=2" -F "notify=0" -F "ipa=@/builds/e.ametrano/unity3d-gitlab-ci-example/Builds/Android/$BUILD_NAME/MeinProjekt/build/outputs/apk/debug/MeinProjekt-debug.apk" -H "X-HockeyAppToken:$HOCKEY_APP_TOKEN" https://rink.hockeyapp.net/api/2/apps/$HOCKEY_APP_ANDROID_ID_DEVELOP/app_versions/upload
      
  artifacts:
    paths:
      - $(pwd)/Builds/Android/$BUILD_NAME/MeinProjekt/build/outputs/apk/
  except:
    - master
    - stagging